Option Strict On
Option Explicit On 

Imports System
Imports Microsoft.ReportingServices.DataProcessing
Imports Microsoft.ReportingServices.Interfaces

Public Class XmlConnection
    Implements IDbConnection
    ' vom Benutzer bergebene Verbindungszeichenfolge
    Private _sVerbindungszeichenfolge As String
    ' Status der Verbindung, standardmig geschlossen
    Private _state As System.Data.ConnectionState = System.Data.ConnectionState.Closed

    '---- Implementierung der erforderlichen Eigenschaften

    Public Property ConnectionString() As String _
           Implements IDbConnection.ConnectionString
        Get
            ' Zurckgeben, was der Benutzer abgelegt hat.
            ' Sicherheitsrelevante Informationen knnen entfernt werden.
            Return _sVerbindungszeichenfolge
        End Get
        Set(ByVal Value As String)
            _sVerbindungszeichenfolge = Value
        End Set
    End Property

    Public ReadOnly Property ConnectionTimeout() As Integer _
            Implements IDbConnection.ConnectionTimeout
        Get
            ' Gibt den Verbindungs-Timeout zurck. 
            ' 0 steht fr eine unendlichen Timeout-Zeit
            Return 0
        End Get
    End Property

    Public ReadOnly Property State() As System.Data.ConnectionState
        Get
            Return _state
        End Get
    End Property
    Public Function BeginTransaction() As IDbTransaction _
                Implements IDbConnection.BeginTransaction
        '-- beginnt eine lokale Transaktion.
        '-- Transaktionen werden in diesem Beispiel nicht untersttzt.
        Throw New NotSupportedException
    End Function 'BeginTransaction

    Public Sub Open() Implements IDbConnection.Open
        '-- ffnet die Verbindung und merkt sich den Status in interner Variablen. 
        '-- In dieser Implementierung ohne echte Funktionalitt
        _state = System.Data.ConnectionState.Open
        Return
    End Sub 'Open

    Public Sub Close() Implements IDbConnection.Close
        '-- Schliet die Verbindung und merkt sich den Status in interner Variablen. 
        '-- In dieser Implementierung ohne echte Funktionalitt
        _state = System.Data.ConnectionState.Closed
        Return
    End Sub 'Close

    Public Function CreateCommand() As IDbCommand _
            Implements IDbConnection.CreateCommand
        '-- Gibt eine neue Instanz eines Command-Objekts zurck
        Return New XmlCommand(Me)
    End Function 'CreateCommand

    Public ReadOnly Property LocalizedName() As String _
            Implements IExtension.LocalizedName
        ' - gibt den lokalisierten Namen des Objekts zurck
        Get
            Return "XML-DatenverarbeitungsErweiterung"
        End Get
    End Property

    Public Sub SetConfiguration(ByVal configuration As String) _
            Implements IExtension.SetConfiguration
        ' Kann dazu verwendet werden, Konfigurationsdaten aus Datei zu lesen
    End Sub

    Public Sub Dispose() Implements IDbConnection.Dispose
    End Sub 'Dispose 
End Class 'XmlConnection